import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsIncomeConfig, GoodsIncomeConfigParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分润配置
 */
export async function pageGoodsIncomeConfig(params: GoodsIncomeConfigParam) {
  const res = await request.get<ApiResult<PageResult<GoodsIncomeConfig>>>(
    MODULES_API_URL + '/shop/goods-income-config/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分润配置列表
 */
export async function listGoodsIncomeConfig(params?: GoodsIncomeConfigParam) {
  const res = await request.get<ApiResult<GoodsIncomeConfig[]>>(
    MODULES_API_URL + '/shop/goods-income-config',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分润配置
 */
export async function addGoodsIncomeConfig(data: GoodsIncomeConfig) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-income-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分润配置
 */
export async function updateGoodsIncomeConfig(data: GoodsIncomeConfig) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-income-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分润配置
 */
export async function removeGoodsIncomeConfig(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-income-config/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分润配置
 */
export async function removeBatchGoodsIncomeConfig(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-income-config/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分润配置
 */
export async function getGoodsIncomeConfig(id: number) {
  const res = await request.get<ApiResult<GoodsIncomeConfig>>(
    MODULES_API_URL + '/shop/goods-income-config/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
